package com.example.alex.myapplication3;


import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.ParcelUuid;
import android.support.v7.app.AppCompatActivity;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.RadioButton;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Toast;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;



import java.io.IOException;
import java.util.Set;
import java.util.UUID;

import static android.app.PendingIntent.getActivity;
import static java.lang.Thread.sleep;

public class MainActivity extends AppCompatActivity {

    private Button fata, spate, stanga, dreapta;
    private Button beep, fars, fard, flash;
    private Button police;
    enum turn {LEFT, RIGHT, NO_TURN};



    private String address = null;
    private ProgressDialog progress;
    private BluetoothAdapter myBluetooth = null;
    private BluetoothSocket btSocket = null;
    private boolean isBtConnected = false;
    /* SPP UUID. Look for it */
    static final UUID myUUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");





    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
      setContentView(R.layout.activity_main);

        fata = (Button) findViewById(R.id.fata);
        spate = (Button) findViewById(R.id.spate);
        stanga = (Button) findViewById(R.id.stanga);
        dreapta = (Button) findViewById(R.id.dreapta);
        fard = (Button) findViewById(R.id.fard);
        fars = (Button) findViewById(R.id.fars);
        flash = (Button) findViewById(R.id.flash);
        beep = (Button) findViewById(R.id.beep);
        police = (Button) findViewById(R.id.police);

         myBluetooth = BluetoothAdapter.getDefaultAdapter();
        if (myBluetooth == null)
        {
            Toast.makeText(getApplicationContext(), "BluetoothAdapter not found",Toast.LENGTH_LONG).show();
            onDestroy();
        }
        if (myBluetooth != null) {
            if (!myBluetooth.isEnabled())
            {
                Toast.makeText(getApplicationContext(), "Bluetooth not enabled",Toast.LENGTH_LONG).show();

                System.exit(0);
            }
            if (myBluetooth.isEnabled()) {
                Set<BluetoothDevice> bondedDevices = myBluetooth.getBondedDevices();
                System.out.println(bondedDevices.size());

                for(BluetoothDevice bt : bondedDevices)
                    System.out.println(bt.getName() + " " + bt.toString());
                Toast.makeText(getApplicationContext(), "Showing Paired Devices",Toast.LENGTH_SHORT).show();

                if (bondedDevices.size() > 0) {
                    while (1>0)
                    {


                    Object[] devices = (Object[]) bondedDevices.toArray();
                    BluetoothDevice device = (BluetoothDevice) devices[0];

                    ParcelUuid[] uuids = device.getUuids();

                    try {
                        btSocket = device.createRfcommSocketToServiceRecord(uuids[0].getUuid());
                        Toast.makeText(getApplicationContext(), "Turned on",Toast.LENGTH_LONG).show();

                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    try {
                        btSocket.connect();
                        break;
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                    }
                }
            }
        }

        System.out.println(address);

        fata.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    fata();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {
                    stop_fata();
                }
                return true;
            }
        });

        spate.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    spate();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {
                    stop_spate();
                }
                return true;
            }
        });


        stanga.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    stanga();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {
                    stop_stanga();
                }
                return true;
            }
        });

        dreapta.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    dreapta();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {
                    stop_dreapta();
                }
                return true;
            }
        });

        beep.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    beep();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {
                    stop_beep();
                }
                return true;
            }
        });

        flash.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    flash();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {

                }
                return true;
            }
        });

        fars.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    fars();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {

                }
                return true;
            }
        });

        fard.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    fard();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {

                }
                return true;
            }
        });

        police.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {

                if (event.getAction() == MotionEvent.ACTION_DOWN) {
                    police();
                } else if (event.getAction() == MotionEvent.ACTION_UP) {

                }
                return true;
            }
        });

    }

    private  void police()
    {
        System.out.println("police mode");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("P".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare police mode");
            }
        }
    }

    private void stanga(){
        System.out.println("mergi in stanga");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("5".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare mers stanga");
            }
        }
    }


    private void stop_stanga(){
        System.out.println("stop mergi in stanga");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("6".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare stop mers stanga");
            }
        }
    }

    private void dreapta(){
        System.out.println("mergi in dreapta");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("7".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare mers dreapta");
            }
        }
    }
    private void stop_dreapta(){
        System.out.println("stop mergi in dreapta");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("8".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare stop mers dreapta");
            }
        }
    }

    private void beep(){
        System.out.println("fa beep");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("H".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare beep start");
            }
        }
    }
    private void stop_beep(){
        System.out.println("opreste beep");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("N".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare beep stop");
            }
        }
    }
    private void fars(){
        System.out.println("aprinde far s");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("L".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare aprinde far s");
            }
        }
    }
    private void fard(){
        System.out.println("aprinde far d");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("R".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare aprinde far d");
            }
        }
    }
    private void flash(){
        System.out.println("flash");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("F".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare aprinde flash");
            }
        }
    }
    private void fata()
    {
        System.out.println("mergi in fata");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("1".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare mers fata");
            }
        }
    }

    private void stop_fata()
    {
        System.out.println("stop fata");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("2".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare stop fata");
            }
        }
    }


    private void spate()
    {
        System.out.println("mergi in spate");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("3".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare mers spate");
            }
        }
    }


    private void stop_spate()
    {
        System.out.println("stop spate");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("4".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare stop spate");
            }
        }
    }


    private void aprinde_led(){
        System.out.println("aprinde led");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("1".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare aprindere");
            }
        }
    }
    private void stinge_led(){
        System.out.println("stinge led");
        if (btSocket != null) {
            try {
                btSocket.getOutputStream().write("0".toString().getBytes());
            } catch (IOException e) {
                System.out.println("eroare stingere");
            }
        }
    }


    protected void onDestroy()
    {

        System.out.println("on destroy");

        try {
            btSocket.getOutputStream().write("X".toString().getBytes());
        } catch (IOException e) {
            System.out.println("eroare stingere");
        }
        try {btSocket.close();} catch (Exception e) {}
        btSocket = null;
        super.onDestroy();

    }




}
